﻿using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using Microsoft.Practices.ServiceLocation;
using Plane.FormationCreator.Formation;
using Plane.FormationCreator.Util;
using Plane.FormationCreator.Views;
using Plane.Util;
using Plane.Windows.Messages;
using System;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Interactivity;

namespace Plane.FormationCreator.ViewModels
{
    /// <summary>
    /// This class contains properties that a View can data bind to.
    /// <para>
    /// See http://www.galasoft.ch/mvvm
    /// </para>
    /// </summary>
    public class ChangePasswordViewModel : ViewModelBase
    {
        private CopterManager _copterManager = ServiceLocator.Current.GetInstance<CopterManager>();
        private MainViewModel _MainViewModel=ServiceLocator.Current.GetInstance<MainViewModel>();
        /// <summary>
        /// Initializes a new instance of the LoginViewModel class.
        /// </summary>
        public ChangePasswordViewModel()
        {

            NewPassword = "";
            OldPassword = "";
            NewPassword1 = "";
            Username = "";
        }


        private string _Username="";
        public string Username
        {
            get { return _Username; }
            set
            {
                Set(nameof(Username), ref _Username, value);
            }
        }




        private string _OldPassword = "";
        public string OldPassword
        {
            get { return _OldPassword; }
            set
            {
                Set(nameof(OldPassword), ref _OldPassword, value);
            }
        }

        private string _NewPassword = "";
        public string NewPassword
        {
            get { return _NewPassword; }
            set
            {
                Set(nameof(NewPassword), ref _NewPassword, value);
            }
        }
        private string _NewPassword1 = "";
        public string NewPassword1
        {
            get { return _NewPassword1; }
            set
            {
                Set(nameof(NewPassword1), ref _NewPassword1, value);
            }
        }







        private ICommand _ExitCommand;
        public ICommand ExitCommand
        {
            get
            {
                return _ExitCommand ?? (_ExitCommand = new RelayCommand<ChangePasswordView>(wd =>
                {
                     if (wd != null)
                    {
                        NewPassword = "";
                        OldPassword = "";
                        NewPassword1 = "";
                        Username = "";
                        wd.Close();
                    }

            }));
            }
        }
        private ICommand _ChangePasswordCommand;
        public ICommand ChangePasswordCommand
        {
            get
            {
                return _ChangePasswordCommand ?? (_ChangePasswordCommand = new RelayCommand<ChangePasswordView>(wd =>
                {
                    if (Username.Trim() == "")
                    {
                        Alert.Show("请输入账号！", "提示", MessageBoxButton.OK, MessageBoxImage.Warning);
                        return;
                    }

                    if (OldPassword=="")
                    {
                        Alert.Show("请输入原密码！", "提示", MessageBoxButton.OK, MessageBoxImage.Warning);
                        return;
                    }

                    if (NewPassword.Length<6)
                    {
                        Alert.Show("新密码长度不能低于6位！", "提示", MessageBoxButton.OK, MessageBoxImage.Warning);
                        return;
                    }

                    if (NewPassword != NewPassword1)
                    {
                        Alert.Show("两次新密码不相同！", "提示", MessageBoxButton.OK, MessageBoxImage.Warning);
                        return;
                    }



                    _copterManager.NetChangePassword(Username.Trim(), OldPassword, NewPassword);

                    //wd.Close();

                }));
            }
        }

    }
}